apiVersion: batch/v1
kind: Job
metadata:
  namespace: predictions
  name: gatling-run
spec:
  backoffLimit: 1
  completions: 1
  activeDeadlineSeconds: 7200
  ttlSecondsAfterFinished: 600
  template:
    spec:
      containers:
      - image: gatling:3.9.5
        name: load-test
        command:
          - /bin/bash
          - -c
          - |
            cp /simulations/ChargeDummy.java /gatling/gatling-charts-highcharts-bundle-3.9.5/user-files/simulations/
            /gatling/gatling-charts-highcharts-bundle-3.9.5/bin/gatling.sh -rm local -s ChargeDummy
        volumeMounts:
          - name: scenario-gatling
            mountPath: /simulations
      volumes:
        - name: scenario-gatling
          configMap:
            name: scenario-gatling
      restartPolicy: Never
---
apiVersion: v1
kind: ConfigMap
metadata:
  namespace: predictions
  name: scenario-gatling
data:
  ChargeDummy.java: |
    import java.time.Duration;
    import java.util.*;

    import io.gatling.javaapi.core.*;
    import io.gatling.javaapi.http.*;
    import io.gatling.javaapi.jdbc.*;

    import static io.gatling.javaapi.core.CoreDsl.*;
    import static io.gatling.javaapi.http.HttpDsl.*;
    import static io.gatling.javaapi.jdbc.JdbcDsl.*;

    public class ChargeDummy extends Simulation {

      {
        HttpProtocolBuilder httpProtocol = http
          .baseUrl("https://dummyserver")
          .inferHtmlResources()
          .acceptHeader("*/*")
          .userAgentHeader("curl/7.85.0");
        


        ScenarioBuilder scn = scenario("ChargeDummy")
          .exec(
            http("request_0")
              .get("/")
          );

        setUp(scn.injectOpen(
          atOnceUsers(1),
          rampUsersPerSec(1).to(30).during(1800),
          constantUsersPerSec(30).during(1200),
          rampUsersPerSec(30).to(0).during(1200)
          )).protocols(httpProtocol);
      }
    }
